#include <iostream>
#include <vector>
using namespace std;

int n, k, t;

struct ornode
 {
  int parent;
  vector <int> leafs;
  int act;
 }ornodes[10001], original_ornodes[10001];

vector <int> leafs[10001];
vector <int> original_leafs[10001];
int parents[10001];
int original_parents[10001];

int groups(int j)
 {
  int sum=1;
  for(int i=0; i<leafs[j].size(); i++) sum+=groups(leafs[j][i]);
  return sum;
 }
bool comp_ornode(ornode a, ornode b)
 {
  return groups(a.act)>groups(b.act);
 }

void remove(int i)
 {
  int par=parents[i];
  for(int j=0; j<leafs[par].size(); j++) 
   {
    if(leafs[par][j]==i) { leafs[par].erase(leafs[par].begin()+j); break; }
   }
  leafs[i].clear();
 }
  
bool sol()
 {
  for(int i=1; i<=n; i++)
    if(groups(i)>=k) return 0;
  return 1;
 }

void restore()
 {
  for(int i=1; i<=n; i++) { ornodes[i]=original_ornodes[i]; parents[i]=original_parents[i]; leafs[i]=original_leafs[i]; }
 }

void apply_changes()
 {
  for(int i=1; i<=n; i++) { original_ornodes[i]=ornodes[i]; original_parents[i]=parents[i]; original_leafs[i]=leafs[i]; }
 }


void optimize_remove(vector <int> &solution, int i)
 {
  for(int j=0; j<solution.size(); j++) { if(j==i) continue; remove(solution[j]); }
 }

void print(vector <int> &solution)
 {
  cout<<solution.size()<<endl;
  cout<<solution[0];
  for(int i=1; i<solution.size(); i++) cout<<" "<<solution[i];
  cout<<endl;
 }


void optimize(vector <int> &solution)
 {
  restore();
  for(int i=solution.size()-1; i>=0; i--)
   {
    optimize_remove(solution, i);
    if(sol()) { restore(); solution.erase(solution.begin()+i); i--; }
    else restore();
   }
 }

void format(vector <int> &solution)
 {
  sort(solution.begin(), solution.end());
 }

int main()
 {
  vector <int> solution;
  cin>>k>>n;
  for(int i=1; i<=n; i++) ornodes[i].act=i;
  for(int i=2; i<=n; i++) { cin>>t; leafs[t].push_back(i); original_leafs[t].push_back(i); ornodes[t].leafs.push_back(i); original_ornodes[t].leafs.push_back(i); ornodes[i].parent=t; original_ornodes[i].parent=t; parents[i]=t; original_parents[i]=t; }
  sort(ornodes+1, ornodes+n+1, comp_ornode);
  sort(original_ornodes+1, original_ornodes+n+1, comp_ornode);
  for(int i=1; i<=n; i++)
   {
    remove(ornodes[i].act);
    if(sol())
     { 
      for(int j=1; j<=i; j++) solution.push_back(ornodes[j].act); 
      optimize(solution);
      format(solution);
      print(solution);
      return 0;
     }
   }
  return 0;
}
